

#include "minigui.ch"
#include "inkey.ch"
#include "common.ch"
#include "dale-aid.ch"

REQUEST DBFCDX, DBFFPT




*********************
function Main()

   PRIVATE MasterFile  := "MASTERFILE"        // Master Records to Tie up every transactions
   PRIVATE Beneficiary := "BENEFICIARY"       // Beneficiary List
   PRIVATE ImageHome   := ""

   PRIVATE cMainAlias := "MASTER"
   PRIVATE cMainOrder := "LastName"  

   PRIVATE acMasterView_   := { "&All", "Acti&ve", "&Doormant" }    // RADIOGROUP rdoViewOptions values
   PRIVATE lUserEvents     := TRUE                                  // Helper variable in RadioViewOptionsChange()
                                                                    // to distinguish between User Events and
                                                                    // program generated events.
   
   PRIVATE acQFindOptions_ := { "Master Account Code",;
                                "Last Name",;
                                "Full Name" }

   //////////////////////////////////////
   // MASTERFILE.DBF Browse Properties //
   //////////////////////////////////////
   PRIVATE acMasterFields_, acMasterHeaders_, anMasterColWidths_, aMasterImages_, aMasterAlignment_
   
   ///////////////////////////////////////
   // BENEFICIARY.DBF Browse Properties //
   ///////////////////////////////////////
   PRIVATE acBnfFields_, acBnfHeaders_, anBnfColWidths_

   ********************************************************************
   ** control flag for validating lostfocus events during data entry **
   ********************************************************************
   PRIVATE lLostFocusEvents := FALSE

   ANNOUNCE RDDSYS
   SET MULTIPLE OFF WARNING
   SET DATE AMERICAN
   SET CENTURY ON
   SET EPOCH TO 1950
   SET WRAP ON
   SET SCOREBOARD OFF
   SET DELETED ON
   SET CONFIRM ON
   SET BELL ON
   SET FONT TO "Verdana" , 9
   SET NAVIGATION EXTENDED
   SET BROWSESYNC ON
   SET TOOLTIPSTYLE BALLOON
   SET TOOLTIPBACKCOLOR { 255 , 255 , 255 }
   SET TOOLTIPFORECOLOR { 0 , 0 , 0 }
   RDDSETDEFAULT("DBFCDX")

   IF ISWINDOWDEFINED( frmGUI_2 )
      DOMETHOD( "frmGUI_2", "Restore" )
      DOMETHOD( "frmGUI_2", "Setfocus" )
      RETURN NIL
   ENDIF         

   IF .NOT. MasterOpen()
      RETURN NIL
   ENDIF
      
   DEFINE WINDOW frmGUI_2;
      AT 0,0;
      WIDTH 703 HEIGHT 550;
      TITLE "Account Master Table";
      ICON ImageHome + "DaleAid.ico";
      MAIN NOMAXIMIZE NOMINIMIZE NOSIZE;
      FONT "Arial" SIZE 9
         
      ON KEY ALT+Q OF frmGUI_2  ACTION frmGUI_2ALTQ()
         
      DEFINE STATUSBAR FONT "Arial" SIZE 8
         STATUSITEM " " + cMainAlias WIDTH 100 ACTION NIL ICON ImageHome + "child.ico"
         STATUSITEM "Index: " + MASTER->( ORDSETFOCUS() ) WIDTH 150
         STATUSITEM "Key: "  + MASTER->( INDEXKEY() ) WIDTH 150
         STATUSITEM "Record No.: " + ALLTRIM( STR( MASTER->( RECNO() ) ) ) WIDTH 130 RAISED
         STATUSITEM "No. of Records: " + ALLTRIM( STR( MASTER->( LASTREC() ) ) ) WIDTH 130
      END STATUSBAR         
      
      @  30, 20  RADIOGROUP rdoViewOptions  OF frmGUI_2;
         OPTIONS acMasterView_ VALUE 1 WIDTH  222 SPACING 74 FONT "Arial" SIZE 9 ON;
         CHANGE RadioViewOptionsChange() HORIZONTAL
         
      @  17, 10 FRAME Frame_ViewOptions OF frmGUI_2 CAPTION "View Options"; 
         WIDTH  240 HEIGHT 50 FONT "Arial" SIZE 9 BACKCOLOR NIL FONTCOLOR NIL OPAQUE
         
      @  35,260 COMBOBOX cboQFind OF frmGUI_2 ITEMS acQFindOptions_ VALUE 2;
         WIDTH  150 HEIGHT 100 ON CHANGE QFindComboChange() FONT "Arial" SIZE 9;
         
      @  35,415 TEXTBOX txbQFind OF frmGUI_2 HEIGHT 24 VALUE "" WIDTH  265;
         FONT "Arial" SIZE 9 TOOLTIP "" MAXLENGTH 100 ON LOSTFOCUS Nil
         
      @  17,254 FRAME Frame_QFind OF frmGUI_2 CAPTION "&Quick Find"; 
         WIDTH  431 HEIGHT 50 FONT "Arial" SIZE 9 BACKCOLOR NIL FONTCOLOR NIL OPAQUE
         
      @  70, 10 FRAME Frame_Master OF frmGUI_2 CAPTION "&Master File Roster:"; 
         WIDTH  675 HEIGHT 227 FONT "Arial" SIZE 9 BACKCOLOR NIL FONTCOLOR NIL OPAQUE
         
      @ 460,190 BUTTON btnNew OF frmGUI_2 CAPTION "Ne&w"; 
         PICTURE ImageHome + "new_field16.bmp" LEFT;
         ACTION NIL WIDTH  100 HEIGHT 28
         
      @ 460,290 BUTTON btnEdit OF frmGUI_2 CAPTION "&Edit"; 
         PICTURE ImageHome + "edit_field.bmp" LEFT ACTION NIL ;
         WIDTH  100 HEIGHT 28
         
      @ 460,390 BUTTON btnDel OF frmGUI_2 CAPTION "Dele&te"; 
         PICTURE ImageHome + "cancel.bmp" LEFT ACTION NIL ;
         WIDTH  100 HEIGHT 28
         
      @ 460,490 BUTTON btnPrint OF frmGUI_2 CAPTION "&Print"; 
         PICTURE ImageHome + "print.bmp" LEFT ACTION NIL ;
         WIDTH  100 HEIGHT 28
         
      @ 460,590 BUTTON btnClose OF frmGUI_2 CAPTION "&Close"; 
         PICTURE ImageHome + "exit20.bmp" LEFT ACTION frmGUI_2.Release ;
         WIDTH  100 HEIGHT 28
         
      @ 300, 10 FRAME Frame_Bnfcry OF frmGUI_2 CAPTION "&List of Beneficiary:"; 
         WIDTH  675 HEIGHT 150 FONT "Arial" SIZE 9 BACKCOLOR NIL FONTCOLOR NIL OPAQUE
         
      @  87, 17 BROWSE brwMaster OF frmGUI_2 WIDTH  661 HEIGHT 203; 
         HEADERS acMasterHeaders_ WIDTHS anMasterColWidths_ WORKAREA MASTER;
         FIELDS acMasterFields_ FONT "Arial" SIZE 9 ON CHANGE brwMasterStatBarUpdate();
         ON DBLCLICK Nil ON HEADCLICK Nil
         
      @ 317, 17 BROWSE brwBeneficiary OF frmGUI_2 WIDTH  661 HEIGHT 126; 
         HEADERS acBnfHeaders_ WIDTHS anBnfColWidths_ WORKAREA BENEFICIARY;
         FIELDS acBnfFields_ FONT "Arial" SIZE 9 ON DBLCLICK Nil ON HEADCLICK Nil
         
         
   END WINDOW
   frmGUI_2.Center
   frmGUI_2.Activate
   DBCLOSEALL()
   RELEASE ALL
   RETURN NIL


   ///////////////////////////////////////////////////////////////////////////////////////////////////
   // Form Control Objects Roster:
   // -------------------------------
   // 
   // FrmGUI_2.rdoViewOptions.Value
   // FrmGUI_2.Frame_1.Value
   // FrmGUI_2.cboQFind.Value
   // FrmGUI_2.txbQFind.Value
   // FrmGUI_2.Frame_2.Value
   // FrmGUI_2.Frame_3.Value
   // FrmGUI_2.btnNew.Value
   // FrmGUI_2.btnEdit.Value
   // FrmGUI_2.btnDel.Value
   // FrmGUI_2.btnPrint.Value
   // FrmGUI_2.btnClose.Value
   // FrmGUI_2.Frame_4.Value
   // FrmGUI_2.brwMaster.Value
   // FrmGUI_2.brwBeneficiary.Value
   // 
   ///////////////////////////////////////////////////////////////////////////////////////////////////



******************************
static function frmGUI_2ALTQ()

   frmGUI_2.cboQFind.Setfocus
   RETURN NIL


****************************
static function MasterOpen()

   LOCAL lRetval := FALSE
   
   BEGIN SEQUENCE
   IF SELECT( "MASTER" ) > 0
      lRetVal := TRUE
      BREAK
   ENDIF
   
   IF .NOT. NETUSE( ( MasterFile ), "MASTER", Shared, ReadWrite )
      MSGSTOP( "Cannot open file " + MasterFile + ".DBF", "OPNERR100" )
      BREAK
   ENDIF
   ORDLISTADD( ( MasterFile ) )
   ORDSETFOCUS( "LastName" , ( MasterFile ) )
   
   IF .NOT. NETUSE( ( Beneficiary ), "BENEFICIARY", Shared, ReadWrite )
      MSGSTOP( "Cannot open file " + Beneficiary + ".DBF", "OPNERR100" )
      BREAK
   ENDIF
   ORDLISTADD( ( Beneficiary ) )
   ORDSETFOCUS( "LastName", ( Beneficiary ) )
   
   acBnfFields_    := { "BENEFICIARY->F2", "BENEFICIARY->F3", "BENEFICIARY->F4", "BENEFICIARY->F5", ;
                        "BENEFICIARY->F6", "BENEFICIARY->F7", "BENEFICIARY->F8" }
                     
   acBnfHeaders_   := { "Last Name", "First Name", "Second Name", "Middle Name", "Full Name", ;
                        "Date of Birth", "Relation" }

   anBnfColWidths_ := { 150, 150, 150, 150, 200, 100, 100 }
   
   acMasterFields_    := { "MASTER->F43", "MASTER->F1" , "MASTER->F2" , "MASTER->F3" , "MASTER->F4" , ;
                           "MASTER->F5" , "MASTER->F6" , "MASTER->F7" , "MASTER->F8" , "MASTER->F9" , ;
                           "MASTER->F10", "MASTER->F11", "MASTER->F12", "MASTER->F13", "MASTER->F14", ;
                           "MASTER->F15", "MASTER->F16", "MASTER->F17", "MASTER->F18", "MASTER->F19", ;
                           "MASTER->F20", "MASTER->F21", "MASTER->F22", "MASTER->F23", "MASTER->F24", ;
                           "MASTER->F25", "MASTER->F26", "MASTER->F27", "MASTER->F28", "MASTER->F29", ;
                           "MASTER->F30", "MASTER->F31", "MASTER->F32", "MASTER->F33", "MASTER->F34", ;
                           "MASTER->F35", "MASTER->F36", "MASTER->F37", "MASTER->F38", "MASTER->F39", ;
                           "MASTER->F40", "MASTER->F41", "MASTER->F42", "MASTER->F44", "MASTER->F45", ;
                           "MASTER->F46", "MASTER->F47" }

   acMasterHeaders_   := { "Status", "Master Account Code", "Date", INDEXMARKER + " Last Name", ;
                           "First Name", "Second Name", "Last Name", "Middle Name", "Full Name", ;
                           "Date of Birth", "Place of Birth", "Philippine Address Line 1", ;
                           "Philippine Address Line 2", "Philippine Address Line 3", "Mobile No.", ;
                           "Residence Tel No.", "Home Fax No.", "Business Tel", "Local or Extensions", ;
                           "Business Fax", "Primary E-mail Address", "Primary Business Website", ;
                           "Country Code", "Overseas Address Line 1", "Overseas Address Line 2", ;
                           "Overseas Address Line 3", "Overseas Mobile No.", "Overseas Residence Tel No.", ;
                           "Overseas Home Fax No.", "Overseas Business Tel", "Overseas Local or Extensions", ;
                           "Overseas Business Fax", "Alternate E-mail Address", "Alternate Business Website", ;
                           "Occupation", "Other Sources of Income", "Contact Person in the Philippines", ;
                           "Address of Contact Person", "Contact Person Phone Information", "Salary", ;
                           "Field of Specialization 1", "Field of Specialization 2", ;
                           "Title (Affix in the Name)", "Date of Account Dormancy", "Date Last Updated", ;
                           "Time of Last Update", "Updated by (User Name)" }

   anMasterColWidths_ := { 30 , 100, 100, 100, 100, 100, 100, 100, 200, 100, 200, 200, 200, 200, 100, ;
                           100, 100, 100, 100, 100, 200, 200, 50 , 200, 200, 200, 100, 100, 100, 100, ;
                           100, 100, 200, 200, 200, 200, 200, 200, 100, 100, 200, 200, 50 , 100, 100, ;
                           100, 100 }
                           
   aMasterImages_     := { ImageHome + "brwNo.bmp", ImageHome + "brwYes.bmp" } 
   aMasterAlignment_  := { BROWSE_JTFY_LEFT }

   DBSELECTAREA( "MASTER" )
   
   lRetVal := TRUE
   END SEQUENCE
   RETURN lRetVal




********************************************************************************
**  Function: brwMasterStatBarUpdate()                                        **
**   Purpose: Update frmGUI_2 status bar.                                     **
**                                                                            **
** Called By: frmGUI_2.brwMaster ON CHANGE ACTION                             **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************
static function brwMasterStatBarUpdate()
   
   frmGUI_2.Statusbar.Item(2) := "Index: " + ALLTRIM( MASTER->( ORDSETFOCUS() ) )
   frmGUI_2.Statusbar.Item(3) := "Key: " + ALLTRIM( MASTER->( INDEXKEY() ) )
   frmGUI_2.Statusbar.Item(4) := "Record No.: " + ALLTRIM( STR( MASTER->( RECNO() ) ) )
   frmGUI_2.Statusbar.Item(5) := "No. of Records: " + ALLTRIM( STR( MASTER->( LASTREC() ) ) )
   RETURN NIL




********************************************************************************
**  Function: brwMasterDisplay()                                              **
**   Purpose: Release and Restate the brwMaster for MASTERFILE.DBF.           **
**            This functionality is required to properly position the         **
**            INDEXMARKER.                                                    **
**                                                                            **
** Called By: QFindComboChange()                                              **
**            RadioViewOptionsChange()                                        **
**                                                                            **
**    Syntax: brwMasterDisplay() --> NIL                                      **
**                                                                            **
** Arguments: None                                                            **
**                                                                            **
**   Returns: Always returns NIL.                                             **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************
static function brwMasterDisplay()

   frmGUI_2.brwMaster.Release   
   
   @  87, 17 BROWSE brwMaster OF frmGUI_2 WIDTH  661 HEIGHT 203; 
   HEADERS acMasterHeaders_ WIDTHS anMasterColWidths_ WORKAREA MASTER;
   FIELDS acMasterFields_ FONT "Arial" SIZE 9 ON CHANGE brwMasterStatBarUpdate();
   ON HEADCLICK Nil ON DBLCLICK Nil 
   
   frmGUI_2.brwMaster.Value := MASTER->( RECNO() )
   frmGUI_2.brwMaster.Refresh
   DisplayBeneficiary()
   RETURN NIL





********************************************************************************
**  Function: DisplayBeneficiary()                                            **
**   Purpose: Filter BENEFICIARY.DBF based on current MASTERFILE->F1 value    **
**                                                                            **
** Called By: brwMasterStatBarUpdate()                                        **
**            brwMasterDisplay()                                              **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************
static function DisplayBeneficiary()

   PRIVATE cThisFilter := MASTER->F1
   
   DBSELECTAREA( "BENEFICIARY" )
   ORDSCOPE( 0, "&cThisFilter" )
   ORDSCOPE( 1, "&cThisFilter" )
   DBGOTOP()
   
   FrmGUI_2.brwBeneficiary.Release
   
   @ 317, 17 BROWSE brwBeneficiary OF frmGUI_2 WIDTH  661 HEIGHT 126; 
   HEADERS acBnfHeaders_ WIDTHS anBnfColWidths_ WORKAREA BENEFICIARY;
   FIELDS acBnfFields_ FONT "Arial" SIZE 9 ON DBLCLICK Nil; 
   ON HEADCLICK Nil

   FrmGUI_2.brwBeneficiary.Value := BENEFICIARY->( RECNO() )
   FrmGUI_2.brwBeneficiary.Refresh
   
   DBSELECTAREA( "MASTER" )
   RETURN NIL



********************************************************************************
**  Function: QFindComboChange()                                              **
**   Purpose: Setup Quick Search Environment.                                 **
**                                                                            **
** Called By: frmGUI_2.cboQFind ON CHANGE ACTION                              **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************
static function QFindComboChange()

   LOCAL nQFindMode := frmGUI_2.cboQFind.Value   
   LOCAL cLastFile  := ALIAS()
   LOCAL cLabel     := ""
   
   
   lUserEvents := FALSE             // turn off user events update on frmGUI_2.rdoViewOptions  
   DBSELECTAREA( "MASTER" )
   DO CASE
      *-> Account Master Code
      CASE nQFindMode = 1
         ///////////////////////////////////////////////////////////////////////////////////
         // Here, in this CASE the following conditions should be set and carry out:      //
         // ----------------------------------------------------------------------------  //
         // (1) if this option is selected, the ordsetfocus() should be set to MasterCode.//
         // (2) Maintain the current record position.                                     //
         // (3) Then if View Options is set to Active or Doormant Account,                //
         //     it should be reset to All settings.                                       //
         // (4) Remove the Index column marker and reposition it to Master Account Code.  //
         // (5) Give control to the user and set focus to txbQFind.                       //
         ///////////////////////////////////////////////////////////////////////////////////
         ORDSETFOCUS( "MasterCode", ( MasterFile ) )
         cLabel := "Master Account Code"
         frmGUI_2.rdoViewOptions.Value := 1
      
      *-> Last Name (Default Settings)
      CASE nQFindMode = 2
         ////////////////////////////////////////////////////////////////////////////
         // Here, in this CASE, the outline below should be the default behaviour: //
         // ---------------------------------------------------------------------- //
         // (1) Check the value of frmGUI_2.rdoViewOptions if the value is:        //
         //     (1.1) 1 - Index focus should be set to LastName                    //
         //     (1.2) 2 - Index focus should be set to Active                      //
         //     (1.3) 3 - Index focus should be set to Doormant                    //
         // (2) Set the Index Column Marker Position to Last Name.                 //
         // (3) Maintain Current Record position                                   //
         // (4) Give the control to user and set the focus to txbQFind.            //
         ////////////////////////////////////////////////////////////////////////////
         ORDSETFOCUS( "LastName", ( MasterFile ) )
         cLabel := "Last Name"
          frmGUI_2.rdoViewOptions.Value := 2
         
      *-> Full Name
      CASE nQFindMode = 3
         ////////////////////////////////////////////////////////////////////////
         // Here, in this CASE, the below functionality should be implemented: //
         // ------------------------------------------------------------------ //
         // (1) Set the current ordsetfocus() to FullName.                     //
         // (2) Maintain the current record position.                          //
         // (3) Set the index column Marker to Full Name                       //
         // (4) Set the rdoViewOptions to 1 which literally means 1.           //
         // (5) Give the control user and set the focus to txbQFind.           //
         ////////////////////////////////////////////////////////////////////////
         ORDSETFOCUS( "FullName", ( MasterFile ) )
         cLabel := "Full Name"
         frmGUI_2.rdoViewOptions.Value := 1
   ENDCASE
   MasterColMarker( cLabel )
   brwMasterDisplay()
   lUserEvents := TRUE     // turn on User Events for frmGUI_2.rdoViewOptions
   frmGUI_2.txbQFind.Setfocus
   RETURN NIL




********************************************************************************
**  Function: RadioViewOptionsChange()                                        **
**   Purpose: Setup Default Browse View Options.                              **
**                                                                            **
** Called By: frmGUI_2.rdoViewOptions ON CHANGE ACTION                        **
**                                                                            **
**    Syntax: RadioViewOptionsChange() --> NIL                                **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns: NIL is always returned.                                         **
**                                                                            **
**     Notes: Depends on inherrited PRIVATE variables declared in             **
**            function MasterFile(). It's default value is TRUE. The variable **
**            name is lUserEvents.                                            **
**                                                                            **
**            When the value of rdoViewOptions is changed programmatically,   **
**            this routine is activated too as a result of the action         **
**            attached with RADIOGROUP object. So lUserEvents is required     **
**            to distinguish the origin that triggers the event.              **
**                                                                            **
********************************************************************************
static function RadioViewOptionsChange()

   IF lUserEvents
      /////////////////////////////////////////////////////////////////////////////////////////////
      // When the user clicks on any view options, default behaviour of the indexmarker          //
      // and cboQFind.Value should be always reset to Last Name (frmGUI_2.cboQFind.Value := 2)   //
      // Then, set lUserEvents TO FALSE and then set it again to true. This is done because      //
      // of the default ACTION of cboQFind will call this routine. Something like a recursive    //
      // call. So by doing this it bypass the commands that won't be necessary to be executed.   //
      // Then set the focus to the brwMaster.                                                    //
      /////////////////////////////////////////////////////////////////////////////////////////////
      lUserEvents := FALSE
      frmGUI_2.cboQFind.Value := 2
      frmGUI_2.brwMaster.Setfocus
      lUserEvents := TRUE
      DBSELECTAREA( "MASTER" )
      DO CASE
         *--> set index to LastName
         CASE frmGUI_2.rdoViewOptions.Value = 1
            ORDSETFOCUS( "LastName", ( MasterFile ) )
         
         *--> set index to Active
         CASE frmGUI_2.rdoViewOptions.Value = 2
            ORDSETFOCUS( "Active", ( MasterFile ) )
         
         *--> set index to Doormant
         CASE frmGUI_2.rdoViewOptions.Value = 3
            ORDSETFOCUS( "Doormant", ( MasterFile ) )
         
      ENDCASE
      **--> set the current active index indicator to last name
      MasterColMarker( "Last Name" )
      brwMasterDisplay()
      frmGUI_2.brwMaster.Value := MASTER->( RECNO() )
      frmGUI_2.brwMaster.Refresh
   ENDIF lUserEvents

   RETURN NIL




********************************************************************************
**  Function: MasterColMarker()                                               **
**   Purpose: To remove and reposition brwMaster Column Label.                **
**                                                                            **
** Called By: QFindComboChange()                                              **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************
static function MasterColMarker( cColumnLabel )

   LOCAL nArrayPos := 0
   
   *--> step #1, find the current INDEXMARKER position in the brwMaster acMasterHeaders_
   nArrayPos := ASCAN( acMasterHeaders_, { | x | SUBSTR( x, 1, 1 ) == INDEXMARKER } )
   IF nArrayPos > 0
   
      *--> step #2, strip off the INDEXMARKER in the brwMaster acMasterHeaders_
      acMasterHeaders_[ nArrayPos ] := ALLTRIM( SUBSTR( acMasterHeaders_[ nArrayPos ], 2 ) )
      
      *--> step #3, find the new brwMaster acMasterHeaders_ to marked with INDEXMARKER
      nArrayPos := ASCAN( acMasterHeaders_, { | x | UPPER( x ) == UPPER( cColumnLabel ) } )
      
      IF nArrayPos > 0
      
         *--> step #4, put the INDEXMARKER on its new positon in brwMaster acMasterHeaders_
         acMasterHeaders_[ nArrayPos ] := INDEXMARKER + " " + acMasterHeaders_[ nArrayPos ]
         
      ENDIF
   ENDIF
   
   RETURN NIL




***************
function NETUSE     && Network Environment dbf Open

   PARAMETERS DataBase, NickName, SharedAccess, NoFileWrite

   LOCAL ReturnValue := TRUE
   PRIVATE bUsedArea   := NickName + "->used()"

   IF SharedAccess = FALSE
      IF LEN(ALLTRIM(NickName)) > 0
         IF NoFileWrite = TRUE
            USE (DataBase) ALIAS &NickName EXCLUSIVE NEW READONLY VIA RDDSETDEFAULT()
         ELSE
            USE (DataBase) ALIAS &NickName EXCLUSIVE NEW VIA RDDSETDEFAULT()
         ENDIF
      ELSE
         IF NoFileWrite = TRUE
            USE (DataBase) EXCLUSIVE NEW READONLY VIA RDDSETDEFAULT()
         ELSE
            USE (DataBase) EXCLUSIVE NEW VIA RDDSETDEFAULT()
         ENDIF
      ENDIF
   ELSE
      IF LEN(ALLTRIM(NickName)) > 0
         IF NoFileWrite = TRUE
            USE (DataBase) ALIAS &NickName SHARED NEW READONLY VIA RDDSETDEFAULT()
         ELSE
            USE (DataBase) ALIAS &NickName SHARED NEW VIA RDDSETDEFAULT()
         ENDIF
      ELSE
         IF NoFileWrite = TRUE
            USE (DataBase) SHARED NEW READONLY VIA RDDSETDEFAULT()
         ELSE
            USE (DataBase) SHARED NEW VIA RDDSETDEFAULT()
         ENDIF
      ENDIF
   ENDIF
   IF NETERR() = TRUE
      MsgInfo("The system can not open " + DataBase + ".DBF","DATABASE FILE OPEN FAILURE")
      ReturnValue := FALSE
   ENDIF
   RETURN ReturnValue
